' Program to estimate the forecasts of rolling regressions of Fair model.
' Version 1 is the first out-of-sample forecast
' Version 2 is the last observation forecast

' Equation 1 is Ray's latest equation
' Equation 2 is my preferred

' INITIALIZE 
wfopen "Z:\RA Work\Data Replication\Nordhaus\qjps_101406.wf1"
smpl @all
vector(32) vv
stom(v,vv)
!eqnum = 1 
group gg1 dem dur g good incum pi war 
group gg2 dem g incum pi

' LOOP FOR EQUATIONS
for %eqnum 1  2 

'VERSION 1: FIRST OUT OF SAMPLE
vector(32) vforc_oos_{%eqnum}
for !n = 1 to 14
   !date=17+!n
   smpl 1 !date
ls v c gg{%eqnum}
 
    smpl !date+1 !date+1
    forecast vfflos_{%eqnum}
   vforc_oos_{%eqnum}(!date+1)=vfflos_{%eqnum}(!date+1)
next
smpl 1 32
mtos(vforc_oos_{%eqnum},forc_oos_{%eqnum})
series  fairerror_oos_{%eqnum}=v-forc_oos_{%eqnum}
 
'VERSION 2: FINAL OBSERVATION IN SAMPLE

vector(32) vforc_lis_{%eqnum}

for !n = 1 to 15
   !date=17+!n
   smpl 1 !date
ls v c gg{%eqnum}
    smpl !date  !date 
    forecast vfflis_{%eqnum}
   vforc_lis_{%eqnum}(!date )=vfflis_{%eqnum}(!date )
next
smpl 1 32
mtos(vforc_lis_{%eqnum},forc_lis_{%eqnum})
series  fairerror_lis_{%eqnum}=v-forc_lis_{%eqnum}

' NOW FOR THE PLOTS OF VARIOUS
smpl 19 32
'plot v forc_lis_{%eqnum} forc_oos_{%eqnum}
plot fairerror_lis_{%eqnum} fairerror_oos_{%eqnum}

!eqnum=!eqnum+1
next

